unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, CH341DLL;

type
  TForm1 = class(TForm)
    ChipIndex: TSpinEdit;
    OpenBtn: TButton;
    CloseBtn: TButton;
    LEDBtn: TButton;
    ReadBtn: TButton;
    Label1: TLabel;
    ReportList: TListBox;
    procedure OpenBtnClick(Sender: TObject);
    procedure CloseBtnClick(Sender: TObject);
    procedure LEDBtnClick(Sender: TObject);
    procedure ReadBtnClick(Sender: TObject);
    procedure AddReport(aLine: String);
  private
    { Private-Deklarationen }
    LEDStatusByte: Byte;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.OpenBtnClick(Sender: TObject);
begin
   //Verbindung zum Chip herstellen... ChipIndex: 0= 1.Chip am USB, 1= 2.Chip, usw.
   if (CH341OpenDevice(ChipIndex.Value)>0) then AddReport('DeviceOpen...OK')
                                           else AddReport('DeviceOpen...error!');
   LEDBtnClick(self);
end;

procedure TForm1.CloseBtnClick(Sender: TObject);
begin
   //Verbindung schliessen...
   CH341CloseDevice(ChipIndex.Value);
   AddReport('Closed');
end;

procedure TForm1.LEDBtnClick(Sender: TObject);
var Buffer: Byte;
    BufferLen: cardinal;
begin
   if LEDStatusByte=0 then LEDStatusByte:=1;

   // Ein Byte senden... (LED 0...7)
   BufferLen:=1;
   Buffer:=not LEDStatusByte; //Output LOW = LED eingeschaltet!
   if CH341MemWriteAddr0(ChipIndex.Value,@Buffer,@BufferLen) then AddReport('Write...OK --- Status = '+IntToStr(Buffer))
                                                             else AddReport('Write error!');
   LEDStatusByte:=LEDStatusByte shl 1; //Lauflicht
end;

procedure TForm1.ReadBtnClick(Sender: TObject);
var Buffer: Byte;
    BufferLen: cardinal;
begin
   //Ein Byte lesen (DIL-Schalter 0...7); Schalterposition ON = Input LOW)
   BufferLen:=1;
   if CH341MemReadAddr0(ChipIndex.Value,@Buffer,@BufferLen) then AddReport('Read...OK --- Status = '+IntToStr(Buffer))
                                                            else AddReport('Read error!');
end;

procedure TForm1.AddReport(aLine: String);
begin
   ReportList.items.Add('Device '+IntToStr(ChipIndex.Value)+': '+aLine);
   if ReportList.items.Count>10 then ReportList.items.Delete(0);
end;

end.
