unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, CH341DLL;

type
  TForm1 = class(TForm)
    ChipIndex: TSpinEdit;
    OpenBtn: TButton;
    CloseBtn: TButton;
    RampBtn: TButton;
    Label1: TLabel;
    ReportList: TListBox;
    Memo1: TMemo;
    procedure OpenBtnClick(Sender: TObject);
    procedure CloseBtnClick(Sender: TObject);
    procedure RampBtnClick(Sender: TObject);
    procedure AddReport(aLine: String);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.OpenBtnClick(Sender: TObject);
begin
   //Verbindung zum Chip herstellen... ChipIndex: 0= 1.Chip am USB, 1= 2.Chip, usw.
   if (CH341OpenDevice(ChipIndex.Value)>0) then AddReport('DeviceOpen...OK')
                                           else AddReport('DeviceOpen...error!');
end;

procedure TForm1.CloseBtnClick(Sender: TObject);
begin
   //Verbindung schliessen...
   CH341CloseDevice(ChipIndex.Value);
   AddReport('Closed');
end;

procedure TForm1.RampBtnClick(Sender: TObject);
var DACA: Byte;
    DACB: Byte;
    aByte: Byte;
    Len: Cardinal;
begin
   // TLC7528 Dual DA CONVERTER; 8 Bit parallel
   // schreiben mit WriteMem0 = DACA; WriteMem1 = DACB
   //
   // LTC7528 pin      CH341A pin
   // ---------------------------
   // D0...D7              D0..D7
   // /WR                  /WR
   // DACB/DACA            A0
   // /CS                  GND (Chip immer selektiert)

   AddReport('DAC A Ramp 0...Vref with CH341MemWriteAddr0');
   AddReport('DAC B Ramp Vref...0 with CH341MemWriteAddr1');

   For aByte:=0 to $FF do //Rampe 0...Vref
   begin
      Len:=1;          // 1 Byte to write
      DACA:=aByte;     // DACA: Ramp up
      DACB:=$FF-aByte; // DACB: Ramp down
      CH341MemWriteAddr0(ChipIndex.Value,@DACA,@Len); // Write to DACA
      CH341MemWriteAddr1(ChipIndex.Value,@DACB,@Len); // Write to DACB
   end;

   AddReport('Done.');

end;

procedure TForm1.AddReport(aLine: String);
begin
   ReportList.items.Add('Device '+IntToStr(ChipIndex.Value)+': '+aLine);
   if ReportList.items.Count>10 then ReportList.items.Delete(0);
   ReportList.Update;
end;

end.
